## unzip 6.0

=== unix/Makefile ===
#==============================================================================
# Makefile for UnZip, UnZipSFX and fUnZip:  Unix and MS-DOS ("real" makes only)
# Version:  6.0                                                     18 Jan 2009
#==============================================================================


# INSTRUCTIONS (such as they are):
#
# "make sunos"	-- makes UnZip in current directory on a generic SunOS 4.x Sun
# "make list"	-- lists all supported systems (targets)
# "make help"	-- provides pointers on what targets to try if problems occur
# "make wombat" -- chokes and dies if you haven't added the specifics for your
#		    Wombat 68000 (or whatever) to the systems list
#
# CF are flags for the C compiler.  LF are flags for the loader.  LF2 are more
# flags for the loader, if they need to be at the end of the line instead of at
# the beginning (for example, some libraries).  FL and FL2 are the corre-
# sponding flags for fUnZip.  LOCAL_UNZIP is an environment variable that can
# be used to add default C flags to your compile without editing the Makefile
# (e.g., -DDEBUG_STRUC, or -FPi87 on PCs using Microsoft C).
#
# Some versions of make do not define the macro "$(MAKE)"; this is rare, but
# if things don't work, try using "make" instead of "$(MAKE)" in your system's
# makerule.  Or try adding the following line to your .login file:
#	setenv MAKE "make"
# (That never works--makes that are too stupid to define MAKE are also too
# stupid to look in the environment--but try it anyway for kicks. :-) )
#
# Memcpy and memset are provided for those systems that don't have them; they
# are in fileio.c and will be used if -DZMEM is included in CF.  These days
# almost all systems have them.
#
# Be sure to test your new UnZip (and UnZipSFX and fUnZip); successful compila-
# tion does not always imply a working program.


#####################
# MACRO DEFINITIONS #
#####################

# Defaults most systems use (use LOCAL_UNZIP in environment to add flags,
# such as -DDOSWILD).

# UnZip flags
CC = cc#	try using "gcc" target rather than changing this (CC and LD
LD = $(CC)#	must match, else "unresolved symbol:  ___main" is possible)
AS = as
LOC = $(D_USE_BZ2) $(LOCAL_UNZIP)
AF = $(LOC)
CFLAGS = -O
CF_NOOPT = -I. -I$(IZ_BZIP2) -DUNIX $(LOC)
CF = $(CFLAGS) $(CF_NOOPT)
LFLAGS1 =
LF = -o unzip$E $(LFLAGS1)
LF2 = -s

# UnZipSFX flags
SL = -o unzipsfx$E $(LFLAGS1)
SL2 = $(LF2)

# fUnZip flags
FL = -o funzip$E $(LFLAGS1)
FL2 = $(LF2)

# general-purpose stuff
#CP = cp
CP = ln
LN = ln
RM = rm -f
CHMOD = chmod
BINPERMS = 755
MANPERMS = 644
STRIP = strip
E =
O = .o
M = unix
SHELL = /bin/sh
MAKEF = -f unix/Makefile

# Version info for unix/unix.c
HOST_VERSINFO=-DIZ_CC_NAME='\"\$$(CC) \"' -DIZ_OS_NAME='\"`uname -a`\"'

# defaults for crc32 stuff and system dependent headers
CRCA_O =
OSDEP_H = unix/unxcfg.h
# default for dependency on auto-configure result, is an empty symbol
# so that the static non-autoconfigure targets continue to work
ACONF_DEP =

# optional inclusion of bzip2 decompression
IZ_OUR_BZIP2_DIR = bzip2
IZ_BZIP2 = $(IZ_OUR_BZIP2_DIR)
## The following symbols definitions need to be set to activate bzip2 support:
#D_USE_BZ2 = -DUSE_BZIP2
#L_BZ2 = -lbz2
#LIBBZ2 = $(IZ_BZIP2)/libbz2.a

# defaults for unzip's "built-in" bzip2 library compilation
CC_BZ = $(CC)
CFLAGS_BZ = $(CFLAGS)

# object files
OBJS1 = unzip$O crc32$O $(CRCA_O) crypt$O envargs$O explode$O
OBJS2 = extract$O fileio$O globals$O inflate$O list$O match$O
OBJS3 = process$O ttyio$O ubz2err$O unreduce$O unshrink$O zipinfo$O
OBJS = $(OBJS1) $(OBJS2) $(OBJS3) $M$O
LOBJS = $(OBJS)
OBJSDLL = $(OBJS:.o=.pic.o) api.pic.o
OBJX = unzipsfx$O crc32_$O $(CRCA_O) crypt_$O extract_$O fileio_$O \
	globals_$O inflate_$O match_$O process_$O ttyio_$O ubz2err_$O $M_$O
LOBJX = $(OBJX)
OBJF = funzip$O crc32$O $(CRCA_O) cryptf$O globalsf$O inflatef$O ttyiof$O
#OBJS_OS2 = $(OBJS1:.o=.obj) $(OBJS2:.o=.obj) os2.obj
#OBJF_OS2 = $(OBJF:.o=.obj)
UNZIP_H = unzip.h unzpriv.h globals.h $(OSDEP_H) $(ACONF_DEP)

# installation
# (probably can change next two to `install' and `install -d' if you have it)
INSTALL = cp
INSTALL_PROGRAM = $(INSTALL)
INSTALL_D = mkdir -p
# on some systems, manext=l and MANDIR=/usr/man/man$(manext) may be appropriate
manext = 1
prefix = /usr/local
BINDIR = $(prefix)/bin#			where to install executables
MANDIR = $(prefix)/man/man$(manext)#	where to install man pages
INSTALLEDBIN = $(BINDIR)/funzip$E $(BINDIR)/unzip$E $(BINDIR)/unzipsfx$E \
	$(BINDIR)/zipgrep$E $(BINDIR)/zipinfo$E
INSTALLEDMAN = $(MANDIR)/funzip.$(manext) $(MANDIR)/unzip.$(manext) \
	$(MANDIR)/unzipsfx.$(manext) $(MANDIR)/zipgrep.$(manext) \
	$(MANDIR)/zipinfo.$(manext)

# Solaris 2.x stuff:
PKGDIR = IZunzip
VERSION = Version 6.0

UNZIPS = unzip$E funzip$E unzipsfx$E
# this is a little ugly...well, OK, it's a lot ugly:
MANS = man/funzip.1 man/unzip.1 man/unzipsfx.1 man/zipgrep.1 man/zipinfo.1
DOCS = funzip.txt unzip.txt unzipsfx.txt zipgrep.txt zipinfo.txt

# list of supported systems/targets in this version
SYSTEMG1 = generic generic_gcc  generic_pkg generic_gccpkg
SYSTEMG2 = generic1 generic2 generic3 generic_bz2 generic_zlib generic_shlib
SYSTEMS1 = 386i 3Bx 7300 7300_gcc aix aix_rt amdahl amdahl_eft apollo aviion
SYSTEMS2 = bsd bsdi bsdi_noasm bull coherent convex cray cray_opt cyber_sgi
SYSTEMS3 = cygwin dec dnix encore eta freebsd gcc gould hk68 hp hpux
SYSTEMS4 = isc isc_gcc isi linux linux_dos linux_noasm linux_shlib linux_shlibz
SYSTEMS5 = lynx macosx macosx_gcc minix mips mpeix next next10 next2x next3x
SYSTEMS6 = nextfat osf1 pixel ptx pyramid qnxnto realix regulus rs6000 sco
SYSTEMS7 = sco_dos sco_sl sco_x286 sequent sgi solaris solaris_pkg stardent
SYSTEMS8 = stellar sunos3 sunos4 sysv sysv_gcc sysv6300 tahoe ti_sysv ultrix
SYSTEMS9 = vax v7 wombat xenix xos


####################
# DEFAULT HANDLING #
####################

# By default, print help on which makefile targets to try.  (The SYSTEM
# variable is no longer supported; use "make <target>" instead.)

help:
	@echo ""
	@echo "  If you're not sure about the characteristics of your system, try typing"
	@echo "  \"make generic\".  This is new and uses the configure script, though it is"
	@echo "  still being worked on."
	@echo ""
	@echo "  If that does not do it, try the original generic which is \"make generic1\"."
	@echo ""
	@echo "  If the compiler barfs and says something unpleasant about \"timezone redefined\","
	@echo "  try typing \"make clean\" followed by \"make generic2\".  If, on the other"
	@echo "  hand, it complains about an undefined symbol _ftime, try typing \"make clean\""
	@echo "  followed by \"make generic3\"."
	@echo ""
	@echo "  One of these actions should produce a working copy of unzip on most Unix"
	@echo "  systems.  If you know a bit more about the machine on which you work, you"
	@echo "  might try \"make list\" for a list of the specific systems supported herein."
	@echo "  (Many of them do exactly the same thing, so don't agonize too much over"
	@echo "  which to pick if two or more sound equally likely.)  Also check out the"
	@echo "  INSTALL file for notes on compiling various targets.  As a last resort,"
	@echo "  feel free to read the numerous comments within the Makefile itself."
	@echo ""
	@echo "  Have a mostly pretty good day."
	@echo ""

list:
	@echo ""
	@echo\
 'Type "make <system>", where <system> is one of the following:'
	@echo ""
	@echo  "	$(SYSTEMG1)"
	@echo  "	$(SYSTEMG2)"
	@echo ""
	@echo  "	$(SYSTEMS1)"
	@echo  "	$(SYSTEMS2)"
	@echo  "	$(SYSTEMS3)"
	@echo  "	$(SYSTEMS4)"
	@echo  "	$(SYSTEMS5)"
	@echo  "	$(SYSTEMS6)"
	@echo  "	$(SYSTEMS7)"
	@echo  "	$(SYSTEMS8)"
	@echo  "	$(SYSTEMS9)"
#	@echo ""
#	@echo\
# 'Targets for related utilities (ZipInfo and fUnZip) include:'
#	@echo ""
#	@echo  "	$(SYS_UTIL1)"
#	@echo  "	$(SYS_UTIL2)"
	@echo ""
	@echo\
 'For further (very useful) information, please read the comments in Makefile.'
	@echo ""

generic_msg:
	@echo ""
	@echo\
 '  Attempting "make generic" now.  If this fails for some reason, type'
	@echo\
 '  "make help" and/or "make list" for suggestions.'
	@echo ""


###############################################
# BASIC COMPILE INSTRUCTIONS AND DEPENDENCIES #
###############################################

# this is for GNU make; comment out and notify zip-bugs if it causes errors
.SUFFIXES:	.c .o .obj .pic.o

# yes, we should be able to use the $O macro to combine these two, but it
# fails on some brain-damaged makes (e.g., AIX's)...no big deal
.c.o:
	$(CC) -c $(CF) $*.c

.c.obj:
	$(CC) -c $(CF) $*.c

.c.pic.o:
	$(CC) -c $(CF) -o $@ $*.c

# this doesn't work...directories are always a pain with implicit rules
#.1.txt:		man/$<
#	nroff -Tman -man $< | col -b | uniq | \
#	 sed 's/Sun Release ..../Info-ZIP        /' > $@


# these rules may be specific to Linux (or at least the GNU groff package)
# and are really intended only for the authors' use in creating non-Unix
# documentation files (which are provided with both source and binary
# distributions).  We should probably add a ".1.txt" rule for more generic
# systems...

funzip.txt:	man/funzip.1
	nroff -Tascii -man man/funzip.1 | col -bx | uniq | expand > $@

unzip.txt:	man/unzip.1
	nroff -Tascii -man man/unzip.1 | col -bx | uniq | expand > $@

unzipsfx.txt:	man/unzipsfx.1
	nroff -Tascii -man man/unzipsfx.1 | col -bx | uniq | expand > $@

zipgrep.txt:	man/zipgrep.1
	nroff -Tascii -man man/zipgrep.1 | col -bx | uniq | expand > $@

zipinfo.txt:	man/zipinfo.1
	nroff -Tascii -man man/zipinfo.1 | col -bx | uniq | expand > $@


all:		generic_msg generic
unzips:		$(UNZIPS)
objs:		$(OBJS)
objsdll:	$(OBJSDLL)
docs:		$(DOCS)
unzipsman:	unzips docs
unzipsdocs:	unzips docs


# EDIT HERE FOR PARALLEL MAKES on Sequent (and others?)--screws up MS-DOS
# make utilities if default:  change "unzip$E:" to "unzip$E:&"

unzip$E:	$(OBJS) $(LIBBZ2)	# add `&' for parallel makes
	$(LD) $(LF) -L$(IZ_BZIP2) $(LOBJS) $(L_BZ2) $(LF2)

unzipsfx$E:	$(OBJX)			# add `&' for parallel makes
	$(LD) $(SL) $(LOBJX) $(SL2)

funzip$E:	$(OBJF)			# add `&' for parallel makes
	$(LD) $(FL) $(OBJF) $(FL2)

zipinfo$E:	unzip$E			# `&' is pointless here...
	@echo\
 '  This is a Unix-specific target.  ZipInfo is not enabled in some MS-DOS'
	@echo\
 '  versions of UnZip; if it is in yours, copy unzip.exe to zipinfo.exe'
	@echo\
 '  or else invoke as "unzip -Z" (in a batch file, for example).'
	$(LN) unzip$E zipinfo$E

# when the optional bzip2 support is provided (as recommended) by sources
# in the 'bzip2' subdirectory, create/update the library:
$(IZ_OUR_BZIP2_DIR)/libbz2.a:
	@echo "Building/updating bzip2 object library..."
	( cd $(IZ_OUR_BZIP2_DIR) ; $(MAKE) -f Makebz2.iz CC="$(CC_BZ)"\
	 CFLAGS="$(CFLAGS_BZ)" RM="rm -f" )


crc32$O:	crc32.c $(UNZIP_H) zip.h crc32.h
crypt$O:	crypt.c $(UNZIP_H) zip.h crypt.h crc32.h ttyio.h
envargs$O:	envargs.c $(UNZIP_H)
explode$O:	explode.c $(UNZIP_H)
extract$O:	extract.c $(UNZIP_H) crc32.h crypt.h
fileio$O:	fileio.c $(UNZIP_H) crc32.h crypt.h ttyio.h ebcdic.h
funzip$O:	funzip.c $(UNZIP_H) crc32.h crypt.h ttyio.h
globals$O:	globals.c $(UNZIP_H)
inflate$O:	inflate.c inflate.h $(UNZIP_H)
list$O:		list.c $(UNZIP_H)
match$O:	match.c $(UNZIP_H)
process$O:	process.c $(UNZIP_H) crc32.h
ttyio$O:	ttyio.c $(UNZIP_H) zip.h crypt.h ttyio.h
ubz2err$O:	ubz2err.c $(UNZIP_H)
unreduce$O:	unreduce.c $(UNZIP_H)
unshrink$O:	unshrink.c $(UNZIP_H)
unzip$O:	unzip.c $(UNZIP_H) crypt.h unzvers.h consts.h
zipinfo$O:	zipinfo.c $(UNZIP_H)

# unzipsfx compilation section
unzipsfx$O:	unzip.c $(UNZIP_H) crypt.h unzvers.h consts.h
	$(CC) -c $(CF) -DSFX -o $@ unzip.c

crc32_$O:	crc32.c $(UNZIP_H) zip.h crc32.h
	$(CC) -c $(CF) -DSFX -o $@ crc32.c

crypt_$O:	crypt.c $(UNZIP_H) zip.h crypt.h crc32.h ttyio.h
	$(CC) -c $(CF) -DSFX -o $@ crypt.c

extract_$O:	extract.c $(UNZIP_H) crc32.h crypt.h
	$(CC) -c $(CF) -DSFX -o $@ extract.c

fileio_$O:	fileio.c $(UNZIP_H) crc32.h crypt.h ttyio.h ebcdic.h
	$(CC) -c $(CF) -DSFX -o $@ fileio.c

globals_$O:	globals.c $(UNZIP_H)

=== debian/changelog ===
unzip (6.0-9ubuntu1.5) trusty-security; urgency=medium

  * debian/patches/16-fix-integer-underflow-csiz-decrypted: updated to fix
    regression in handling 0-byte files (LP: #1513293)

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 09 Nov 2015 09:16:57 -0600

unzip (6.0-9ubuntu1.4) trusty-security; urgency=medium

  * SECURITY UPDATE: denial of service and possible code execution via
    heap overflow
    - debian/patches/14-cve-2015-7696: add check to crypt.c.
    - CVE-2015-7696
  * SECURITY UPDATE: infinite loop when extracting empty bzip2 data
    - debian/patches/15-cve-2015-7697: check for empty input in extract.c.
    - CVE-2015-7697
  * SECURITY UPDATE: unsigned overflow on invalid input
    - debian/patches/16-fix-integer-underflow-csiz-decrypted: make sure
      csiz_decrypted doesn't overflow in extract.c.
    - No CVE number

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 29 Oct 2015 10:33:05 -0400

unzip (6.0-9ubuntu1.3) trusty-security; urgency=medium

  * SECURITY UPDATE: heap overflow in charset_to_intern()
    - debian/patches/06-unzip60-alt-iconv-utf8: updated to fix buffer
      overflow in unix/unix.c.
    - CVE-2015-1315
  * SECURITY REGRESSION: regression with executable jar files
    - debian/patches/09-cve-2014-8139-crc-overflow: updated to fix
      regression.
  * SECURITY REGRESSION: regression with certain compressed data headers
    - debian/patches/12-cve-2014-9636-test-compr-eb: updated to fix
      regression.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 17 Feb 2015 14:17:20 -0500

unzip (6.0-9ubuntu1.2) trusty-security; urgency=medium

  * SECURITY UPDATE: heap overflow via mismatched block sizes
    - debian/patches/12-cve-2014-9636-test-compr-eb: ensure compressed and
      uncompressed block sizes match when using STORED method in extract.c.
    - CVE-2014-9636

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 29 Jan 2015 11:37:34 -0500

unzip (6.0-9ubuntu1.1) trusty-security; urgency=medium

  * SECURITY UPDATE: CRC32 verification heap-based overflow
    - debian/patches/09-cve-2014-8139-crc-overflow: check extra block
      length in extract.c.
    - CVE-2014-8139
  * SECURITY UPDATE: out-of-bounds write issue in test_compr_eb()
    - debian/patches/10-cve-2014-8140-test-compr-eb: properly validate
      sizes in extract.c.
    - CVE-2014-8140
  * SECURITY UPDATE: out-of-bounds read issues in getZip64Data()
    - debian/patches/11-cve-2014-8141-getzip64data: validate extra fields
      in fileio.c, check sizes in process.c.
    - CVE-2014-8141

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 07 Jan 2015 16:14:02 -0500

unzip (6.0-9ubuntu1) saucy; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Add patch from archlinux which adds the -O option, allowing a charset
      to be specified for the proper unzipping of non-Latin and non-Unicode
      filenames.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 13 May 2013 13:00:12 +0100

unzip (6.0-9) unstable; urgency=low

  * Added NO_WORKING_ISPRINT to DEFINES so that UTF8 filenames are
    displayed correctly. Reported by Slavek Banko. Closes: #682682.
  * Use the right strip command when cross-building. Closes: #695141.

 -- Santiago Vila <sanvila@debian.org>  Sun, 24 Feb 2013 17:12:00 +0100

unzip (6.0-8ubuntu1) raring; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Add patch from archlinux which adds the -O option, allowing a charset
      to be specified for the proper unzipping of non-Latin and non-Unicode
      filenames.
    - Use correct strip program when cross-building.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 13 Dec 2012 16:08:03 +0000

unzip (6.0-8) unstable; urgency=low

  * Made unzip -X to actually restore uid/gid information.
    Closes: #689212. Thanks to Axel Scheepers for the report.
  * Disabled memcpy, as it is being used on overlapping buffers,
    leading to data corruption. Closes: #694601.
    Thanks to M Joonas Pihlaja for the report.

 -- Santiago Vila <sanvila@debian.org>  Wed, 28 Nov 2012 12:41:34 +0100

unzip (6.0-7ubuntu2) raring; urgency=low

  * Use correct strip program when cross-building.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 04 Dec 2012 15:15:23 +0000

unzip (6.0-7ubuntu1) quantal; urgency=low

  * Merge from Debian unstable. Remaining change:
    - Added patch from archlinux which adds the -O option allowing a charset
    to be specified for the proper unzipping of non-latin and non-unicode
    filenames.
  * Merge adds Multi-Arch: foreign. (LP: #1010450)

 -- Logan Rosen <logatronico@gmail.com>  Sun, 05 Aug 2012 21:31:45 -0400

unzip (6.0-7) unstable; urgency=low

  * Added Multi-Arch: foreign. Closes: #678812.

 -- Santiago Vila <sanvila@debian.org>  Sat, 30 Jun 2012 14:17:42 +0200

unzip (6.0-6) unstable; urgency=low

  * Added hardening flags. Closes: #656268.

 -- Santiago Vila <sanvila@debian.org>  Sun, 01 Apr 2012 00:01:40 +0200

unzip (6.0-5) unstable; urgency=low

  * Handle the PKWare verification bit of internal attributes.
    Patch taken from 6.10 beta. Thanks to sms. Closes: #630078.

 -- Santiago Vila <sanvila@debian.org>  Fri, 01 Jul 2011 19:06:08 +0200

unzip (6.0-4ubuntu1) natty; urgency=low

  * Added patch from archlinux which adds the -O option allowing a charset
    to be specified for the proper unzipping of non-latin and non-unicode
    filenames. (LP: #580961)

 -- Brian Thomason <brian.thomason@canonical.com>  Wed, 12 Jan 2011 20:08:14 -0500

unzip (6.0-4) unstable; urgency=low

  * Added homepage field to control file.
  * Switch to 3.0 (quilt) source format.
  * Support cross-build.

 -- Santiago Vila <sanvila@debian.org>  Sun, 21 Feb 2010 17:01:00 +0100

unzip (6.0-3) unstable; urgency=low

  * Added "set -e" to postinst and postrm.

 -- Santiago Vila <sanvila@debian.org>  Tue, 09 Feb 2010 23:53:42 +0100

unzip (6.0-2) unstable; urgency=low

  * Do not ignore errors from make clean (lintian warning)


=== debian/control ===
Source: unzip
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Santiago Vila <sanvila@debian.org>
Standards-Version: 3.9.2
Build-Depends: libbz2-dev
Homepage: http://www.info-zip.org/UnZip.html

Package: unzip
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: unzip-crypt (<< 5.41)
Replaces: unzip-crypt (<< 5.41)
Suggests: zip
Multi-Arch: foreign
Description: De-archiver for .zip files
 InfoZIP's unzip program. With the exception of multi-volume archives
 (ie, .ZIP files that are split across several disks using PKZIP's /& option),
 this can handle any file produced either by PKZIP, or the corresponding
 InfoZIP zip program.
 .
 This version supports encryption.

=== debian/rules ===
#!/usr/bin/make -f

package = unzip
docdir = debian/tmp/usr/share/doc/$(package)
history = History.600

CC = gcc
export DEB_BUILD_MAINT_OPTIONS=hardening=-format
CFLAGS := `dpkg-buildflags --get CFLAGS` -Wall
LDFLAGS := `dpkg-buildflags --get LDFLAGS`
CPPFLAGS := `dpkg-buildflags --get CPPFLAGS`
DEFINES = -DACORN_FTYPE_NFS -DWILD_STOP_AT_DIR -DLARGE_FILE_SUPPORT \
 -DUNICODE_SUPPORT -DUNICODE_WCHAR -DUTF8_MAYBE_NATIVE -DNO_LCHMOD \
 -DDATE_FORMAT=DF_YMD -DUSE_BZIP2 -DIZ_HAVE_UXUIDGID -DNOMEMCPY \
 -DNO_WORKING_ISPRINT

STRIP = true

DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  CC=$(DEB_HOST_GNU_TYPE)-gcc
  STRIPCMD=$(DEB_HOST_GNU_TYPE)-strip
else
  STRIPCMD=strip
endif

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
  STRIP = $(STRIPCMD) --remove-section=.comment --remove-section=.note
endif

build:
	$(MAKE) -f unix/Makefile D_USE_BZ2=-DUSE_BZIP2 L_BZ2=-lbz2 \
		CC="$(CC)" LF2="$(LDFLAGS)" \
		CF="$(CFLAGS) $(CPPFLAGS) -I. $(DEFINES)" unzips
	touch build

clean:
	rm -f build
	$(MAKE) -f unix/Makefile clean
	rm -rf *~ debian/tmp debian/*~ debian/files* debian/substvars

binary-indep: build

binary-arch: build
	rm -rf debian/tmp
	install -d debian/tmp/DEBIAN $(docdir)
	cd debian/tmp && install -d usr/bin usr/man/man1 usr/lib/mime/packages
	$(MAKE) -f unix/Makefile install prefix=`pwd`/debian/tmp/usr
	install -m 755 debian/postinst debian/postrm debian/tmp/DEBIAN
	install -m 644 debian/mime debian/tmp/usr/lib/mime/packages/$(package)
	cat debian/copyright.in LICENSE > $(docdir)/copyright
	cp debian/changelog $(docdir)/changelog.Debian
	cp -p History.* BUGS ToDo $(docdir)
	cd $(docdir) && gzip -9 changelog.Debian History.*
	ln -s $(history).gz $(docdir)/changelog.gz
	cd debian/tmp/usr/bin && $(STRIP) funzip unzip unzipsfx zipinfo
	gzip -r9 debian/tmp/usr/man
	cd debian/tmp && mv usr/man usr/share
	dpkg-shlibdeps debian/tmp/usr/bin/unzip
	dpkg-gencontrol
	cd debian/tmp && \
		md5sum `find * -type f ! -regex "DEBIAN/.*"` > DEBIAN/md5sums
	chown -R 0:0 debian/tmp
	chmod -R go=rX debian/tmp
	dpkg --build debian/tmp ..

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean

## unzip 6.0-1maemo1

=== debian/changelog ===
unzip (6.0-1maemo1) unstable; urgency=low

  * Using debian/optify to store the files in /opt.
  * Removing man and some documentation from the package.

 --  Daniel Martin Yerga <dyerga@gmail.com>  Sat, 02 Jan 2010 20:02:40 +0100

=== debian/control ===
Source: unzip
Section: utils
Priority: optional
Maintainer: Daniel Martin Yerga <dyerga@gmail.com>
Standards-Version: 3.7.2
Build-Depends: libbz2-dev, maemo-optify

Package: unzip
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: unzip-crypt (<< 5.41)
Replaces: unzip-crypt (<< 5.41)
Suggests: zip
Description: De-archiver for .zip files
 InfoZIP's unzip program. With the exception of multi-volume archives
 (ie, .ZIP files that are split across several disks using PKZIP's /& option),
 this can handle any file produced either by PKZIP, or the corresponding
 InfoZIP zip program.
 .
 This version supports encryption.

=== debian/rules ===
#!/usr/bin/make -f

package = unzip
docdir = debian/tmp/usr/share/doc/$(package)
history = History.600

CC = gcc
CFLAGS = -g -Wall
DEFINES = -DACORN_FTYPE_NFS -DWILD_STOP_AT_DIR -DLARGE_FILE_SUPPORT \
 -DUNICODE_SUPPORT -DUNICODE_WCHAR -DUTF8_MAYBE_NATIVE -DNO_LCHMOD \
 -DDATE_FORMAT=DF_YMD -DUSE_BZIP2

INSTALL_PROGRAM = install

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
  INSTALL_PROGRAM += -s
endif

build:
	$(MAKE) -f unix/Makefile LF2="" D_USE_BZ2=-DUSE_BZIP2 L_BZ2=-lbz2 \
		CC="$(CC)" CF="$(CFLAGS) -I. $(DEFINES)" unzips
	touch build

clean:
	rm -f build
	-$(MAKE) -f unix/Makefile clean
	rm -rf *~ debian/tmp debian/*~ debian/files* debian/substvars

binary-indep: build

binary-arch: build
	rm -rf debian/tmp
	install -d debian/tmp/DEBIAN $(docdir)
	#cd debian/tmp && install -d usr/bin usr/man/man1
	$(MAKE) -f unix/Makefile install prefix=`pwd`/debian/tmp/usr \
		INSTALL_PROGRAM="$(INSTALL_PROGRAM)"
	cat debian/copyright.in LICENSE > $(docdir)/copyright
	cp debian/changelog $(docdir)/changelog.Debian
	#cp -p History.* BUGS ToDo $(docdir)
	#cd $(docdir) && gzip -9 changelog.Debian History.*
	cd $(docdir) && gzip -9 changelog.Debian
	ln -s $(history).gz $(docdir)/changelog.gz
	#gzip -r9 debian/tmp/usr/man
	rm -Rf debian/tmp/usr/man
	#cd debian/tmp && mv usr/man usr/share
	dpkg-shlibdeps unzip
	dpkg-gencontrol -isp
	cd debian/tmp && \
		md5sum `find * -type f ! -regex "DEBIAN/.*"` > DEBIAN/md5sums
	chown -R root:root debian/tmp
	chmod -R go=rX debian/tmp
	dpkg --build debian/tmp ..

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean

## unzip 6.0-2~5.52~ja2

=== debian/changelog ===
unzip (6.0-2~5.52~ja2) karmic; urgency=low

  * Rename source archive.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Wed, 28 Oct 2009 04:52:40 +0900

unzip (6.0-2~5.52~ja1) karmic; urgency=low

  * Rebuild for Karmic.
  * set version number to higher than official unzip version(6.0-1).

 -- Jun Kobayashi <jkbys@ubuntu.com>  Wed, 28 Oct 2009 04:32:46 +0900

unzip (5.52-12ubuntu2~ja1) jaunty; urgency=low
  
  * paches/01_japanese_charset.dpatch
   - patch for Japanese filename and password.

 -- Hajime Mizuno <mizuno@as.airnet.ne.jp>  Wed, 15 Apr 2009 18:32:57 +0900

unzip (5.52-12ubuntu1) jaunty; urgency=low

  * Merge from debian unstable, remaining changes:
    - debian/rules: Configure with large file support.
    - unzip.c: Change banner to indicate Ubuntu modification.
    - support UTF-8 file names.

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 12 Nov 2008 16:51:21 +0100

unzip (5.52-11ubuntu1) intrepid; urgency=low

  * Merge with Debian; remaining changes:
    - debian/rules: Configure with large file support.
    - unzip.c: Change banner to indicate Ubuntu modification.
    - support UTF-8 file names.

 -- Matthias Klose <doko@debian.org>  Wed, 25 Jun 2008 15:57:03 +0000

unzip (5.52-10ubuntu2) hardy; urgency=low

  * SECURITY UPDATE: arbitrary code execution via heap corruption.
  * inflate.c: fix invalid free() calls, patch from Tavis Ormandy.
  * References
    CVE-2008-0888

 -- Kees Cook <kees@ubuntu.com>  Wed, 19 Mar 2008 12:08:30 -0700

unzip (5.52-10ubuntu1) gutsy; urgency=low

  * Merge with Debian; remaining changes:
    - debian/rules: Configure with large file support.
    - unzip.c: Change banner to indicate Ubuntu modification.
    - support UTF-8 file names.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2007 10:03:01 +0000

unzip (5.52-9ubuntu3) feisty; urgency=low

  * Apply patch from https://bugzilla.altlinux.org/long_list.cgi?buglist=4871
    to support UTF-8 file names. Ubuntu #10979.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 31 Mar 2007 13:10:40 +0200

unzip (5.52-9ubuntu2) feisty; urgency=low

  * Rebuild for changes in the amd64 toolchain.
  * Set Ubuntu maintainer address.

 -- Matthias Klose <doko@ubuntu.com>  Mon,  5 Mar 2007 01:27:17 +0000

unzip (5.52-9ubuntu1) feisty; urgency=low

  * Merge from debian unstable.

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 22 Nov 2006 12:10:13 +0100

unzip (5.52-8ubuntu1) edgy; urgency=low

  * Merge from debian unstable; only Ubuntu changes left:
    - debian/rules: Configure with large file support.
    - unzip.c: Change banner to indicate Ubuntu modification.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 30 Jun 2006 11:28:40 +0200

unzip (5.52-6ubuntu4) dapper; urgency=low

  * const.h, process.c: Limit the maximum length of displayed file names to
    512 bytes, to avoid spewage with excessively long file names (which caused
    buffer overflows until the recent security fix for CVE-2005-4667).
  * Thanks to Santiago Vila for pointing this out.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 23 Mar 2006 13:00:08 +0100

unzip (5.52-6ubuntu3) dapper; urgency=low

  * Previous security update scrambled the output fields in the contents
    listing, fix that regression.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 15 Feb 2006 12:11:47 +0100

unzip (5.52-6ubuntu2) dapper; urgency=low

  * SECURITY UPDATE: Arbitrary code execution on specially crafted long file
    names (which should not happen in many scenarios, though).
  * unzpriv.h, Info macro: 
    - Use snprintf() instead of sprintf() as inner formatting function.
    - Use fputs() instead of fprintf() as outer function to ignore leftover
      format strings which might not have been substituted in the inner
      snprintf().
    - Throw away the three different implementations of that macro and use
      just one safe one.
    - CVE-2005-4667

 -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 10 Feb 2006 20:14:01 +0100

unzip (5.52-6ubuntu1) dapper; urgency=low

  * Resynchronise with Debian.

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 28 Dec 2005 11:02:39 +0100

unzip (5.52-5ubuntu1) dapper; urgency=low

  * Resynchronise with Debian.
  * Repaired totally scrambled changelog.
  * unzip.c: Change Debian banner to 'Ubuntu', as advised by the Debian
    maintainer.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 21 Nov 2005 20:38:41 +0100

unzip (5.52-4ubuntu1) dapper; urgency=low

  * Resynchronise with Debian.

 -- Michael Vogt <michael.vogt@ubuntu.com>  Fri, 11 Nov 2005 13:16:29 +0100

unzip (5.52-3ubuntu2) breezy; urgency=low

  * SECURITY UPDATE: Fix file permission modification race.
  * unix/unix.c: Use fchmod() instead of chmod() to change permissions on the
    files unzip actually created, not the files another attacker might have
    hardlinked to in the meantime.
  * CAN-2005-2475

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 29 Sep 2005 17:02:50 +0200

unzip (5.52-3ubuntu1) breezy; urgency=low

  * Resynchronise with Debian.

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 28 Jun 2005 15:46:02 +0200

unzip (5.51-2ubuntu1) hoary; urgency=low

  * Fixed unzip of >2GB files, thanks to patch from ard at kwaak.net 

 -- Thom May <thom@ubuntu.com>  Mon, 28 Feb 2005 15:25:52 +0000

## unzip 6.0-2~5.52~ja4

=== debian/changelog ===
unzip (6.0-2~5.52~ja4) lucid; urgency=low

  * No-change rebuild.

 -- Hajime Mizuno <hajime.mizuno@gmail.com>  Fri, 14 May 2010 16:27:04 +0900

unzip (6.0-2~5.52~ja4~ppa1) lucid; urgency=low

  * fix patchs/01_japanese_charset.dpatch for lucid

 -- Fumihito YOSHIDA <hito@kugutsu.org>  Wed, 12 May 2010 00:13:00 +0900

unzip (6.0-2~5.52~ja3) lucid; urgency=low

  * Rebuild for Lucid.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Sat, 10 Apr 2010 02:09:54 +0900

## unzip 6.0-5~5.52~ja1

=== debian/changelog ===
unzip (6.0-5~5.52~ja1) maverick; urgency=low

  * change version number.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Tue, 05 Oct 2010 03:37:40 +0900

unzip (6.0-4~5.52~ja1) maverick; urgency=low

  * change version number.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Mon, 04 Oct 2010 03:43:53 +0900

unzip (6.0-2~5.52~ja5) maverick; urgency=low

  * Rebuild for Maverick.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Mon, 04 Oct 2010 03:12:43 +0900

## unzip 6.0-5~5.52~ja2

=== debian/changelog ===
unzip (6.0-5~5.52~ja2) natty; urgency=low

  * Rebuild for Natty.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Sat, 16 Apr 2011 00:49:03 +0900

## unzip 6.0-5~5.52~ja3

=== debian/changelog ===
unzip (6.0-5~5.52~ja3) oneiric; urgency=low

  * Rebuild for Oneiric.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Fri, 30 Sep 2011 17:56:11 +0900

## unzip 6.0-5~5.52~ja4

=== debian/changelog ===
unzip (6.0-5~5.52~ja4) precise; urgency=low

  * Rebuild for Precise.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Tue, 17 Apr 2012 01:13:51 +0900

## unzip 6.0-8~5.52~ja1

=== debian/changelog ===
unzip (6.0-8~5.52~ja1) quantal; urgency=low

  * Rebuild for Quantal.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Wed, 03 Oct 2012 19:22:31 +0900

## unzip 6.0-9~5.52~ja1

=== debian/changelog ===
unzip (6.0-9~5.52~ja1) raring; urgency=low

  * Rebuild for Raring.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Fri, 26 Apr 2013 14:12:01 +0900

## unzip 6.0-10~5.52~ja1

=== debian/changelog ===
unzip (6.0-10~5.52~ja1) saucy; urgency=low

  * Rebuild for Saucy.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Sat, 12 Oct 2013 14:17:39 +0900

## unzip 6.0-10~5.52~ja2

=== debian/changelog ===
unzip (6.0-10~5.52~ja2) trusty; urgency=medium

  * Rebuild for Trusty.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Fri, 18 Apr 2014 07:47:55 +0900

## unzip 6.0-13~5.52~ja1

=== debian/changelog ===
unzip (6.0-13~5.52~ja1) utopic; urgency=medium

  * version up

 -- Jun Kobayashi <jkbys@ubuntu.com>  Sun, 26 Oct 2014 00:17:22 +0900

unzip (6.0-10~5.52~ja4) utopic; urgency=medium

  * Rebuild for Utopc.

 -- Jun Kobayashi <jkbys@ubuntu.com>  Sat, 25 Oct 2014 23:51:04 +0900

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: unzip
 Section: utils
 Priority: optional
-Maintainer: Daniel Martin Yerga <dyerga@gmail.com>
+Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Santiago Vila <sanvila@debian.org>
 Standards-Version: 3.7.2
-Build-Depends: libbz2-dev, maemo-optify
+Build-Depends: dpatch
 
 Package: unzip
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

package = unzip
docdir = debian/tmp/usr/share/doc/$(package)
history = History.552

CC = gcc
CFLAGS = -g -Wall $$(getconf LFS_CFLAGS)
DEFINES = -DACORN_FTYPE_NFS -DWILD_STOP_AT_DIR -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -D_MBCS 
INSTALL_PROGRAM = install

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
  INSTALL_PROGRAM += -s
endif

build: patch
	$(MAKE) -f unix/Makefile LF2="" \
		CC="$(CC)" CF="$(CFLAGS) -I. $(DEFINES)" unzips
	touch build

clean: unpatch
	rm -f build
	-$(MAKE) -f unix/Makefile clean
	rm -rf *~ debian/tmp debian/*~ debian/files* debian/substvars

binary-indep: build

binary-arch: build
	rm -rf debian/tmp
	install -d debian/tmp/DEBIAN $(docdir)
	cd debian/tmp && install -d usr/bin usr/man/man1
	$(MAKE) -f unix/Makefile install prefix=`pwd`/debian/tmp/usr \
		INSTALL_PROGRAM="$(INSTALL_PROGRAM)"
	cat debian/copyright.in LICENSE > $(docdir)/copyright
	cp debian/changelog $(docdir)/changelog.Debian
	cp -p History.* BUGS ToDo $(docdir)
	cd $(docdir) && gzip -9 changelog.Debian History.*
	ln -s $(history).gz $(docdir)/changelog.gz
	gzip -r9 debian/tmp/usr/man
	cd debian/tmp && mv usr/man usr/share
	dpkg-shlibdeps unzip
	dpkg-gencontrol -isp
	cd debian/tmp && \
		md5sum `find * -type f ! -regex "DEBIAN/.*"` > DEBIAN/md5sums
	chown -R root:root debian/tmp
	chmod -R go=rX debian/tmp
	dpkg --build debian/tmp ..

binary: binary-indep binary-arch

patch: patch-stamp
patch-stamp:
	dpatch apply-all

unpatch:
	dpatch deapply-all
	rm -rf patch-stamp debian/patched

.PHONY: binary binary-arch binary-indep clean

## unzip 6.0-21ubuntu1.2%2B9.0trisquel1

=== debian/changelog ===
unzip (6.0-21ubuntu1.2+9.0trisquel1) etiona-security; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 13 Oct 2022 12:51:21 +0000

unzip (6.0-21ubuntu1.2) bionic-security; urgency=medium

  * SECURITY UPDATE: Null pointer dereference in unzip (LP: #1957077)
    - debian/patches/CVE-2021-4217.patch: Fix null pointer dereference and use
      of uninitialized data
    - CVE-2021-4217
  * SECURITY UPDATE: Out-of-bound write vulnerability in unzip
    - debian/patches/CVE-2022-0529.patch: Fix wide string conversion in
      process.c
    - debian/patches/CVE-2022-0530.patch: Add missing error handling in
      fileio.c and process.c
    - CVE-2022-0529
    - CVE-2022-0530

 -- Nishit Majithia <nishit.majithia@canonical.com>  Fri, 07 Oct 2022 22:38:33 +0530

unzip (6.0-21ubuntu1.1) bionic-security; urgency=medium

  * SECURITY UPDATE: buffer overflow in password protected ZIP archives
    - debian/patches/20-cve-2018-1000035-unzip-buffer-overflow.patch: Perform
      check before allocating memory in fileio.c.
    - CVE-2018-1000035 
  * SECURITY UPDATE: denial of service (resource consumption)
    - debian/patches/22-cve-2019-13232-fix-bug-in-undefer-input.patch: Fix bug
      in undefer_input() of fileio.c that misplaced the input state.
    - debian/patches/23-cve-2019-13232-zip-bomb-with-overlapped-entries.patch:
      Detect and reject a zip bomb using overlapped entries.
    - debian/patches/24-cve-2019-13232-do-not-raise-alert-for-misplaced-central-directory.patch:
      Do not raise a zip bomb alert for a misplaced central directory.
    - CVE-2019-13232

 -- Avital Ostromich <avital.ostromich@canonical.com>  Thu, 26 Nov 2020 16:01:36 -0500

unzip (6.0-21ubuntu1) artful; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add patch from archlinux which adds the -O option, allowing a charset
      to be specified for the proper unzipping of non-Latin and non-Unicode
      filenames.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 27 Apr 2017 22:23:23 -0700

unzip (6.0-21) unstable; urgency=medium

  * Rename all debian/patches/* to have .patch ending.
  * Update 12-cve-2014-9636-test-compr-eb.patch to follow revised
    patch "unzip-6.0_overflow3.diff" from mancha (patch author).
    Update also to follow upstream coding style.
  * Drop workaround for gcc optimization bug on ARM (GCC Bug #764732)
    in the hope that it's not present anymore in GCC-6.
  * Allow source to be cross-built. Closes: #836051.
  * Do not ignore Unix Timestamps. Closes: #842993. Patch by the author.
  * Fix CVE-2014-9913, buffer overflow in unzip. Closes: #847485.
    Patch by the author.
  * Fix CVE-2016-9844, buffer overflow in zipinfo. Closes: #847486.
    Patch by the author.

 -- Santiago Vila <sanvila@debian.org>  Sun, 11 Dec 2016 21:03:30 +0100

unzip (6.0-20ubuntu2) artful; urgency=medium

  * No-change rebuild to pick up -fPIE compiler default in static
    libraries

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 21 Apr 2017 20:58:49 +0000

unzip (6.0-20ubuntu1) xenial; urgency=medium

  * Resynchronise with Debian. Remaining changes:
    - Add patch from archlinux which adds the -O option, allowing a charset
      to be specified for the proper unzipping of non-Latin and non-Unicode
      filenames.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 20 Nov 2015 09:16:18 -0500

unzip (6.0-20) unstable; urgency=high

  * Update debian/patches/16-fix-integer-underflow-csiz-decrypted to fix
    regression on encrypted 0-byte files. Closes: #804595.
    Thanks to Marc Deslauriers for the fix in Ubuntu.

 -- Santiago Vila <sanvila@debian.org>  Mon, 09 Nov 2015 22:15:32 +0100

unzip (6.0-19ubuntu2) xenial; urgency=medium

  * debian/patches/16-fix-integer-underflow-csiz-decrypted: updated to fix
    regression in handling 0-byte files (LP: #1513293)

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 09 Nov 2015 08:51:17 -0600

unzip (6.0-19ubuntu1) xenial; urgency=medium

  * Resynchronise with Debian. Remaining changes:
    - Add patch from archlinux which adds the -O option, allowing a charset
      to be specified for the proper unzipping of non-Latin and non-Unicode
      filenames.

 -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 23 Oct 2015 15:58:43 +0200

unzip (6.0-19) unstable; urgency=medium

  * Fix infinite loop when extracting password-protected archive.
    This is CVE-2015-7697. Closes: #802160.
  * Fix heap overflow when extracting password-protected archive.
    This is CVE-2015-7696. Closes: #802162.
  * Fix additional unsigned overflow on invalid input.
  * Thanks a lot to Raphaël Hertzog for the squeeze-lts release,
    from which this upload is mainly derived.

 -- Santiago Vila <sanvila@debian.org>  Thu, 22 Oct 2015 12:12:46 +0200

unzip (6.0-18) unstable; urgency=medium

  * Ship a debian/copyright file in source package instead of generating
    it a build time. Closes: #795567.

 -- Santiago Vila <sanvila@debian.org>  Sun, 16 Aug 2015 23:34:42 +0200

unzip (6.0-17) unstable; urgency=medium

  * Switch to dh.
  * Remove build date embedded in binary to make the build reproducible.
    Thanks to Jérémy Bobbio <lunar@debian.org>. Closes: #782851.

 -- Santiago Vila <sanvila@debian.org>  Sun, 17 May 2015 12:41:52 +0200

unzip (6.0-16) unstable; urgency=medium

  * Update 09-cve-2014-8139-crc-overflow to fix CVE-2014-8139
    the right way (patch by the author). Closes: #775640.
  * Update 10-cve-2014-8140-test-compr-eb to apply cleanly.
  * Update 12-cve-2014-9636-test-compr-eb to follow the extract.c
    file from the author.

 -- Santiago Vila <sanvila@debian.org>  Fri, 30 Jan 2015 22:16:08 +0100

unzip (6.0-15) unstable; urgency=medium

  * Fix heap overflow. Ensure that compressed and uncompressed
    block sizes match when using STORED method in extract.c.
    Patch taken from Ubuntu. Thanks a lot. Closes: #776589.
    For reference, this is CVE-2014-9636.



=== debian/control ===
Source: unzip
Section: utils
Priority: optional
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer: Santiago Vila <sanvila@debian.org>
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9), libbz2-dev
Homepage: http://www.info-zip.org/UnZip.html

Package: unzip
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: zip
Multi-Arch: foreign
Description: De-archiver for .zip files
 InfoZIP's unzip program. With the exception of multi-volume archives
 (ie, .ZIP files that are split across several disks using PKZIP's /& option),
 this can handle any file produced either by PKZIP, or the corresponding
 InfoZIP zip program.
 .
 This version supports encryption.

## unzip 6.0-25ubuntu1+10.0trisquel1

=== debian/changelog ===
unzip (6.0-25ubuntu1+10.0trisquel1) nabia; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Fri, 08 Jan 2021 18:43:03 +0000

unzip (6.0-25ubuntu1) eoan; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add patch from archlinux which adds the -O option, allowing a charset
      to be specified for the proper unzipping of non-Latin and non-Unicode
      filenames.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 15 Aug 2019 23:39:12 -0700

unzip (6.0-25) unstable; urgency=medium

  * Apply one more patch by Mark Adler:
  - Do not raise a zip bomb alert for a misplaced central directory.
    This should allow Firefox to build again. Closes: #932404.
    Reported by Peter Green. Hopefully CVE-2019-13232 is fixed now.

 -- Santiago Vila <sanvila@debian.org>  Sat, 27 Jul 2019 18:01:36 +0200

unzip (6.0-24ubuntu1) eoan; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add patch from archlinux which adds the -O option, allowing a charset
      to be specified for the proper unzipping of non-Latin and non-Unicode
      filenames.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 15 Jul 2019 22:02:02 -0700

unzip (6.0-24) unstable; urgency=medium

  * Apply two patches by Mark Adler:
  - Fix bug in undefer_input() that misplaced the input state.
  - Detect and reject a zip bomb using overlapped entries. Closes: #931433.
    Bug discovered by David Fifield. For reference, this is CVE-2019-13232.

 -- Santiago Vila <sanvila@debian.org>  Thu, 11 Jul 2019 18:03:34 +0200

unzip (6.0-23ubuntu1) eoan; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add patch from archlinux which adds the -O option, allowing a charset
      to be specified for the proper unzipping of non-Latin and non-Unicode
      filenames.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 28 May 2019 23:05:51 -0700

unzip (6.0-23) unstable; urgency=medium

  * Fix lame code in fileio.c which parsed 64-bit values incorrectly.
    Thanks to David Fifield for the report. Closes: #929502.

 -- Santiago Vila <sanvila@debian.org>  Wed, 29 May 2019 00:24:08 +0200

unzip (6.0-22ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add patch from archlinux which adds the -O option, allowing a charset
      to be specified for the proper unzipping of non-Latin and non-Unicode
      filenames.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Feb 2019 11:32:00 -0800

unzip (6.0-22) unstable; urgency=medium

  * Fix buffer overflow in password protected ZIP archives. Closes: #889838.
    Patch borrowed from SUSE. For reference, this is CVE-2018-1000035.
  * Rules-Requires-Root: no.

 -- Santiago Vila <sanvila@debian.org>  Sat, 09 Feb 2019 18:12:00 +0100

## unzip 6.0-25ubuntu1.1+10.0trisquel1

=== debian/changelog ===
unzip (6.0-25ubuntu1.1+10.0trisquel1) nabia-security; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 13 Oct 2022 12:51:45 +0000

unzip (6.0-25ubuntu1.1) focal-security; urgency=medium

  * SECURITY UPDATE: Null pointer dereference in unzip (LP: #1957077)
    - debian/patches/CVE-2021-4217.patch: Fix null pointer dereference and use
      of uninitialized data
    - CVE-2021-4217
  * SECURITY UPDATE: Out-of-bound write vulnerability in unzip
    - debian/patches/CVE-2022-0529.patch: Fix wide string conversion in
      process.c
    - debian/patches/CVE-2022-0530.patch: Add missing error handling in
      fileio.c and process.c
    - CVE-2022-0529
    - CVE-2022-0530

 -- Nishit Majithia <nishit.majithia@canonical.com>  Fri, 07 Oct 2022 22:39:47 +0530

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 9), libbz2-dev
 Homepage: http://www.info-zip.org/UnZip.html
+Rules-Requires-Root: no
 
 Package: unzip
 Architecture: any

## unzip 6.0-26ubuntu3.1+11.0trisquel1

=== debian/changelog ===
unzip (6.0-26ubuntu3.1+11.0trisquel1) aramo-security; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Fri, 14 Oct 2022 12:38:51 +0000

unzip (6.0-26ubuntu3.1) jammy-security; urgency=medium

  * SECURITY UPDATE: Null pointer dereference in unzip (LP: #1957077)
    - debian/patches/CVE-2021-4217.patch: Fix null pointer dereference and use
      of uninitialized data
    - CVE-2021-4217
  * SECURITY UPDATE: Out-of-bound write vulnerability in unzip
    - debian/patches/CVE-2022-0529.patch: Fix wide string conversion in
      process.c
    - debian/patches/CVE-2022-0530.patch: Add missing error handling in
      fileio.c and process.c
    - CVE-2022-0529
    - CVE-2022-0530

 -- Nishit Majithia <nishit.majithia@canonical.com>  Fri, 07 Oct 2022 22:51:05 +0530

unzip (6.0-26ubuntu3) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 25 Mar 2022 10:59:33 +0100

unzip (6.0-26ubuntu2) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:25:55 +0200

unzip (6.0-26ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Add patch from archlinux which adds the -O option, allowing a charset
      to be specified for the proper unzipping of non-Latin and non-Unicode
      filenames.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 29 Jan 2021 12:10:20 -0800

unzip (6.0-26) unstable; urgency=medium

  * Two more patches from Mark Adler for CVE-2019-13232. Closes: #963996.
  - Fix bug in UZbunzip2() that incorrectly updated G.incnt.
  - Fix bug in UZinflate() that incorrectly updated G.incnt.
  * Avoid weird zipgrep errors when no members are present.
    Thanks to Kevin Locke. Closes: #972233.
  * Update dependency on debhelper.

 -- Santiago Vila <sanvila@debian.org>  Sun, 10 Jan 2021 15:34:00 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Santiago Vila <sanvila@debian.org>
-Standards-Version: 3.9.6
-Build-Depends: debhelper (>= 9), libbz2-dev
+Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (= 13), libbz2-dev
 Homepage: http://www.info-zip.org/UnZip.html
 Rules-Requires-Root: no
